import { PointType } from "../types";
import { BaseAction } from "../actions/BaseAction";
import { BaseEntity } from "../BaseEntity";
import { DiagramEngine } from "../DiagramEngine";
import { DiagramModel } from "../models/DiagramModel";
export default abstract class AbstractBoard extends BaseEntity {
    protected engine: DiagramEngine;
    protected canvas: Element;
    constructor(engine: DiagramEngine);
    setCanvas(canvas: Element): void;
    getCanvas(): Element;
    abstract getRelativePoint(x: any, y: any): PointType;
    abstract navigate(action: BaseAction, event: MouseEvent): any;
    abstract navigateTo(coordinates: PointType): any;
    abstract navigateOnZoom(zoomDifference: number): any;
    canPlaceNode(coords: PointType): boolean;
    centerNodes(): void;
    protected getModels(): DiagramModel;
}
