import { DiagramEngine } from "../../DiagramEngine";
import { ConnectorsType, PathType, RoutingInterface } from "../types";
import { LinkModel } from "storm-react-diagrams";
export declare const ROUTING_SCALING_FACTOR = 5;
export default class PathFinding implements RoutingInterface {
    engine: DiagramEngine;
    connectors: ConnectorsType;
    constructor(engine: DiagramEngine, connectors: ConnectorsType);
    getPath(link: LinkModel): PathType;
    private adjustConnectors;
    /**
     * Taking as argument a fully unblocked walking matrix, this method
     * finds a direct path from point A to B.
     */
    private calculateDirectPath;
    /**
     * Using @link{#calculateDirectPath}'s result as input, we here
     * determine the first walkable point found in the matrix that includes
     * blocked paths.
     */
    private calculateLinkStartEndCoords;
    /**
     * Puts everything together: merges the paths from/to the centre of the ports,
     * with the path calculated around other elements.
     */
    private calculateDynamicPath;
    private adjustPoint;
    private getPointsDistance;
}
